<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Illuminate\Support\Facades\Config;

use App\Models\{ProviderOauth,Site,User};
use App\Jobs\ProviderTokenRefresh as Job;

class ProviderTokenRefresh extends Command
{
	/**
	 * The name and signature of the console command.
	 *
	 * @var string
	 */
	protected $signature = 'provider:token:refresh'
	.' {provider : Supplier Name}'
	.' {user? : User Email}';

	/**
	 * The console command description.
	 *
	 * @var string
	 */
	protected $description = 'Refresh users access/refresh token';

	/**
	 * Execute the console command.
	 *
	 * @return int
	 */
	public function handle()
	{
		$uo = User::where('email',$this->argument('user') ?: config('osb.admin'))->singleOrFail();

		$so = ProviderOauth::where('name',$this->argument('provider'))->singleOrFail();
		if (($x=$so->tokens->where('user_id',$uo->id))->count() !== 1)
			abort(500,sprintf('Unknown Tokens for [%s]',$uo->email));

		Job::dispatchSync($x->pop());

		return self::SUCCESS;
	}
}